const fs = require('fs');
const { HttpsProxyAgent } = require('https-proxy-agent');

function readProxiesFromFile(filePath) {
  try {
    // Read proxies from the file
    const data = fs.readFileSync(filePath, 'utf8');
    const proxies = data.split('\n').map((line) => line.trim()).filter(Boolean);
    return proxies;
  } catch (error) {
    console.error('Error reading proxies from file:', error.message);
    return [];
  }
}

// List of proxies
const proxies = readProxiesFromFile('proxies.txt');

function getRandomProxy() {
  // Select a random proxy from the list
  const randomIndex = Math.floor(Math.random() * proxies.length);
  return proxies[randomIndex];
}

async function fetchData() {
  const proxyUrl = getRandomProxy();

console.log("proxy: " + proxyUrl)
  try {
    const response = await fetch("https://api.discord.gx.games/v1/direct-fulfillment", {
      method: "POST",
      headers: {
        "accept": "*/*",
        "accept-language": "de-DE,de;q=0.9,en-US;q=0.8,en;q=0.7",
        "content-type": "application/json",
        "sec-ch-ua": "\"Chromium\";v=\"118\", \"Opera GX\";v=\"104\", \"Not=A?Brand\";v=\"99\"",
        "sec-ch-ua-mobile": "?0",
        "sec-ch-ua-platform": "\"Windows\"",
        "sec-fetch-dest": "empty",
        "sec-fetch-mode": "cors",
        "sec-fetch-site": "cross-site",
        "Referer": "https://www.opera.com/",
        "Referrer-Policy": "strict-origin-when-cross-origin"
      },
      // Set the proxy for the request
      agent: new HttpsProxyAgent('http://' + proxyUrl),
      body: JSON.stringify({ "partnerUserId": "f8cdd155-4c38-42af-be98-bddf38455f54" }),
    });

    const result = await response.json();
    const output = "https://discord.com/billing/partner-promotions/1180231712274387115/" + result.token;

    fs.appendFileSync('output.txt', output + '\n');

    console.log("code: " + result.token);
  } catch (error) {
    console.error('Error fetching data:', error.message);
  }
}

function runForever() {
  fetchData()
    .finally(() => setTimeout(runForever, 10));
}

runForever();
